#ifndef CRITICALPATH_H_
#define CRITICALPATH_H_

//
// Include the C standard library header file here
//

#include <stdio.h>

//
// Other header files are included here
//

#include "Stack.h"

//
// Define the data structure here
//

#define MAX_VERTEX_NUM 50				// Maximum number of vertices
typedef long BOOL;
#define TRUE 1
#define FALSE 0

// Edge (arc)
typedef struct EdgeNode 
{
	int vertex;							// Vertex field. That is, the index of the vertex in the vertex array.
	int weight;							// Edge weights
	struct EdgeNode* nextedge;			// Chain domain. Point to the next Edge (arc).
	BOOL isCritical;					// Whether for key activities.True is true,FALSE is not true	
	const char* name;					// Side (arc) activity name
}EdgeNode;

// vertex
typedef struct VexNode 
{
	// Use a string as the vertex's stored value. You can also think of it as the vertex's name.
	const char* name;					
	EdgeNode* firstarc;	        		// Pointing to the first side arc.
	int Indegree;						// indegree of vertex.
}VexNode;

// Graph. Use adjacency list storage
typedef struct GraphList 
{
	VexNode vexlist[MAX_VERTEX_NUM];	// Vertex table
	int length;							// Vertex number
}GraphList;

//
// Declare the function here
//

void InitGraph(GraphList* pGraphList);
void DeleteGraph(GraphList* pGraphList);
void FindInDegree(GraphList* pGraphList);
int CriticalPath(GraphList* pGraphList);
void OutputResult(GraphList* pGraphList);

//
// Declare global variables here
//

extern Stack stack; 
extern Stack TopoSortResult;
extern int Ve[MAX_VERTEX_NUM];
extern int Vl[MAX_VERTEX_NUM];

#endif /* CRITICALPATH_H_ */
