﻿# 阅读实验源代码
**main.c文件**   
在 main 函数中首先初始化了图和栈，然后调用CriticalPath函数查找图中关键路径,最后销毁了图。   
在main函数的后面，分别定义了计算图中顶点入度函数FindInDegree和图的拓扑排序函数TopologicalSort和图的关键路径查找函数CriticalPath，以及图的初始化函数和销毁函数。其中，计算顶点入度函数FindInDegree和拓扑排序函数TopologicalSort以及图中关键路径查找函数CriticalPath的函数体还不完整，留给读者完成。  
**CriticalPath.h文件**   
定义了与图相关的数据结构并声明了相关的操作函数和全局变量。注意，此头文件中还包含了栈模块的头文件Stack.h。   
**Stack.h文件**   
定义了与栈相关的数据结构并声明了相关的操作函数。   
**Stack.c文件**   
定义了与栈相关的操作函数。   
# 在演示模式下调试项目
**按照下面的步骤调试项目：**
1.	按F7生成项目。
2.	在演示模式下，按F5启动调试项目。程序会在观察点函数的开始位置中断。
3.	重复按F5，直到调试过程结束。

在调试的过程中，每执行“演示流程”窗口中的一行后，仔细观察“可视化数据”窗口内容所发生的变化，理解关键路径函数的执行过程。“可视化数据”窗口显示的数据信息（如下图所示），包括：
-	求图中关键路径所需的事件最早发生时间数组和事件最迟发生时间数组。
-	图的邻接表。
a)	包括顶点名称字符串，如果该顶点是关键路径上关联的顶点，该顶点的填充色为蓝色，字体颜色为白色；如果该顶点在栈中，该顶点的填充色为绿色。
b)	顶点的邻接点（即图中的边、或者弧），和邻接点中包含的权值、 顶点下标和活动名称，如果该邻接顶点所包含的活动为关键路径上活动，该邻接点的填充色为蓝色，字体颜色为白色。
c)	在调试的过程中，可以看到游标的移动。
-	计算事件最迟发生时间数组时使用的栈。
-	在图中，栈中的顶点的填充色为绿色；关键路径上的顶点的填充色为蓝色，字体的颜色为白色；关键路径上边的颜色为红色；游标指向的当前边的颜色为红色；在调试的过程中，可以看到游标的移动。

![关键路径1](./img/18_1.png)
![关键路径2](./img/18_2.png)
# 编写源代码并通过验证
**按照下面的步骤继续实验：**
1.	为FindInDegree、TopologicalSort和CriticalPath函数编写源代码。注意，尽量使用已定义的局部变量。
2.	按F7生成项目。如果生成失败，根据“输出”窗口中的提示信息修改源代码中的语法错误。
3.	按Alt+F5启动验证。如果验证失败，可以使用“输出”窗口中的“比较”功能，或者在“非演示模式”下按F5启动调试后重复按F10单步调试读者编写的源代码，从而定位错误的位置，然后回到步骤1。  

>
**`提示：`**在搜索关键路径的过程中，把边（或者弧）的isCritical域设置为TRUE，表示这条边（或者弧）是关键路径上的关键活动。
>

# 教师参考答案
请教师用户首先访问[教师项目群组](https://www.codecode.net/engintime/ds-lab/teachers-packet),申请权限并审核通过后，再[domain relative url](engintime/ds-lab/teachers-packet/Lab018.git)访问本项目的参考答案
